/* game-window.c generated by valac 0.44.3, the Vala compiler
 * generated from game-window.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2015, 2016, 2019 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>

typedef enum  {
	GAME_WINDOW_FLAGS_SHOW_UNDO = 1 << 0,
	GAME_WINDOW_FLAGS_SHOW_START_BUTTON = 1 << 1
} GameWindowFlags;

#define TYPE_GAME_WINDOW_FLAGS (game_window_flags_get_type ())

#define TYPE_GAME_WINDOW (game_window_get_type ())
#define GAME_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_WINDOW, GameWindow))
#define GAME_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_WINDOW, GameWindowClass))
#define IS_GAME_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_WINDOW))
#define IS_GAME_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_WINDOW))
#define GAME_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_WINDOW, GameWindowClass))

typedef struct _GameWindow GameWindow;
typedef struct _GameWindowClass GameWindowClass;
typedef struct _GameWindowPrivate GameWindowPrivate;
enum  {
	GAME_WINDOW_0_PROPERTY,
	GAME_WINDOW_NUM_PROPERTIES
};
static GParamSpec* game_window_properties[GAME_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	GAME_WINDOW_PLAY_SIGNAL,
	GAME_WINDOW_WAIT_SIGNAL,
	GAME_WINDOW_BACK_SIGNAL,
	GAME_WINDOW_UNDO_SIGNAL,
	GAME_WINDOW_NUM_SIGNALS
};
static guint game_window_signals[GAME_WINDOW_NUM_SIGNALS] = {0};

struct _GameWindow {
	GtkApplicationWindow parent_instance;
	GameWindowPrivate * priv;
};

struct _GameWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _GameWindowPrivate {
	gboolean window_is_tiled;
	gboolean window_is_maximized;
	gboolean window_is_fullscreen;
	gint window_width;
	gint window_height;
	gboolean game_finished;
	GtkHeaderBar* headerbar;
	GtkStack* stack;
	GtkButton* start_game_button;
	GtkButton* new_game_button;
	GtkButton* back_button;
	GtkButton* unfullscreen_button;
	GtkBox* controls_box;
	GtkBox* game_box;
	GtkBox* new_game_box;
	GtkBox* side_box;
	GtkWidget* view;
	GSimpleAction* back_action;
	GSimpleAction* undo_action;
	GtkMenuButton* info_button;
};

static gint GameWindow_private_offset;
static gpointer game_window_parent_class = NULL;

GType game_window_flags_get_type (void) G_GNUC_CONST;
GType game_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameWindow, g_object_unref)
static void game_window_new_game_cb (GameWindow* self);
static void _game_window_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
static void game_window_start_game_cb (GameWindow* self);
static void _game_window_start_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self);
static void game_window_back_cb (GameWindow* self);
static void _game_window_back_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self);
static void game_window_undo_cb (GameWindow* self);
static void _game_window_undo_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self);
static void game_window_toggle_hamburger (GameWindow* self);
static void _game_window_toggle_hamburger_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self);
static void _gtk_window_unfullscreen_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
GameWindow* game_window_new (const gchar* css_resource,
                             const gchar* name,
                             gint width,
                             gint height,
                             gboolean maximized,
                             gboolean start_now,
                             GameWindowFlags flags,
                             GtkBox* new_game_screen,
                             GtkWidget* _view);
GameWindow* game_window_construct (GType object_type,
                                   const gchar* css_resource,
                                   const gchar* name,
                                   gint width,
                                   gint height,
                                   gboolean maximized,
                                   gboolean start_now,
                                   GameWindowFlags flags,
                                   GtkBox* new_game_screen,
                                   GtkWidget* _view);
static void game_window_install_ui_action_entries (GameWindow* self);
static void game_window_size_allocate_cb (GameWindow* self);
static void _game_window_size_allocate_cb_gtk_widget_size_allocate (GtkWidget* _sender,
                                                             GtkAllocation* allocation,
                                                             gpointer self);
static gboolean game_window_window_state_event_cb (GameWindow* self,
                                            GdkEventWindowState* event);
static gboolean _game_window_window_state_event_cb_gtk_widget_window_state_event (GtkWidget* _sender,
                                                                           GdkEventWindowState* event,
                                                                           gpointer self);
static void game_window_show_view (GameWindow* self);
static void game_window_show_new_game_screen (GameWindow* self);
void game_window_shutdown (GameWindow* self,
                           GSettings* settings);
void game_window_add_to_sidebox (GameWindow* self,
                                 GtkWidget* widget);
void game_window_cannot_undo_more (GameWindow* self);
void game_window_new_turn_start (GameWindow* self,
                                 gboolean can_undo);
void game_window_set_subtitle (GameWindow* self,
                               const gchar* subtitle);
void game_window_finish_game (GameWindow* self);
static void game_window_finalize (GObject * obj);

static const GActionEntry GAME_WINDOW_ui_action_entries[6] = {{"new-game", _game_window_new_game_cb_gsimple_action_activate_callback}, {"start-game", _game_window_start_game_cb_gsimple_action_activate_callback}, {"back", _game_window_back_cb_gsimple_action_activate_callback}, {"undo", _game_window_undo_cb_gsimple_action_activate_callback}, {"toggle-hamburger", _game_window_toggle_hamburger_gsimple_action_activate_callback}, {"unfullscreen", _gtk_window_unfullscreen_gsimple_action_activate_callback}};

GType
game_window_flags_get_type (void)
{
	static volatile gsize game_window_flags_type_id__volatile = 0;
	if (g_once_init_enter (&game_window_flags_type_id__volatile)) {
		static const GFlagsValue values[] = {{GAME_WINDOW_FLAGS_SHOW_UNDO, "GAME_WINDOW_FLAGS_SHOW_UNDO", "show-undo"}, {GAME_WINDOW_FLAGS_SHOW_START_BUTTON, "GAME_WINDOW_FLAGS_SHOW_START_BUTTON", "show-start-button"}, {0, NULL, NULL}};
		GType game_window_flags_type_id;
		game_window_flags_type_id = g_flags_register_static ("GameWindowFlags", values);
		g_once_init_leave (&game_window_flags_type_id__volatile, game_window_flags_type_id);
	}
	return game_window_flags_type_id__volatile;
}

static inline gpointer
game_window_get_instance_private (GameWindow* self)
{
	return G_STRUCT_MEMBER_P (self, GameWindow_private_offset);
}

static void
_game_window_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
#line 186 "../src/game-window.vala"
	game_window_new_game_cb ((GameWindow*) self);
#line 199 "game-window.c"
}

static void
_game_window_start_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self)
{
#line 186 "../src/game-window.vala"
	game_window_start_game_cb ((GameWindow*) self);
#line 209 "game-window.c"
}

static void
_game_window_back_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 186 "../src/game-window.vala"
	game_window_back_cb ((GameWindow*) self);
#line 219 "game-window.c"
}

static void
_game_window_undo_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 186 "../src/game-window.vala"
	game_window_undo_cb ((GameWindow*) self);
#line 229 "game-window.c"
}

static void
_game_window_toggle_hamburger_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self)
{
#line 186 "../src/game-window.vala"
	game_window_toggle_hamburger ((GameWindow*) self);
#line 239 "game-window.c"
}

static void
_gtk_window_unfullscreen_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
#line 186 "../src/game-window.vala"
	gtk_window_unfullscreen ((GtkWindow*) self);
#line 249 "game-window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 74 "../src/game-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 257 "game-window.c"
}

static void
_game_window_size_allocate_cb_gtk_widget_size_allocate (GtkWidget* _sender,
                                                        GtkAllocation* allocation,
                                                        gpointer self)
{
#line 90 "../src/game-window.vala"
	game_window_size_allocate_cb ((GameWindow*) self);
#line 267 "game-window.c"
}

static gboolean
_game_window_window_state_event_cb_gtk_widget_window_state_event (GtkWidget* _sender,
                                                                  GdkEventWindowState* event,
                                                                  gpointer self)
{
	gboolean result;
	result = game_window_window_state_event_cb ((GameWindow*) self, event);
#line 91 "../src/game-window.vala"
	return result;
#line 279 "game-window.c"
}

GameWindow*
game_window_construct (GType object_type,
                       const gchar* css_resource,
                       const gchar* name,
                       gint width,
                       gint height,
                       gboolean maximized,
                       gboolean start_now,
                       GameWindowFlags flags,
                       GtkBox* new_game_screen,
                       GtkWidget* _view)
{
	GameWindow * self = NULL;
	GtkWidget* _tmp7_;
	GtkHeaderBar* _tmp8_;
	GtkBox* _tmp9_;
	GtkBox* _tmp22_;
	GtkWidget* _tmp23_;
	GtkBox* _tmp24_;
	GtkWidget* _tmp25_;
	GtkWidget* _tmp26_;
	GtkWidget* _tmp27_;
	GtkWidget* _tmp28_;
#line 68 "../src/game-window.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 68 "../src/game-window.vala"
	g_return_val_if_fail (new_game_screen != NULL, NULL);
#line 68 "../src/game-window.vala"
	g_return_val_if_fail (_view != NULL, NULL);
#line 68 "../src/game-window.vala"
	self = (GameWindow*) g_object_new (object_type, NULL);
#line 70 "../src/game-window.vala"
	if (css_resource != NULL) {
#line 315 "game-window.c"
		GtkCssProvider* css_provider = NULL;
		GtkCssProvider* _tmp0_;
		GtkCssProvider* _tmp1_;
		GdkScreen* gdk_screen = NULL;
		GdkScreen* _tmp2_;
		GdkScreen* _tmp3_;
		GdkScreen* _tmp4_;
#line 72 "../src/game-window.vala"
		_tmp0_ = gtk_css_provider_new ();
#line 72 "../src/game-window.vala"
		css_provider = _tmp0_;
#line 73 "../src/game-window.vala"
		_tmp1_ = css_provider;
#line 73 "../src/game-window.vala"
		gtk_css_provider_load_from_resource (_tmp1_, (const gchar*) css_resource);
#line 74 "../src/game-window.vala"
		_tmp2_ = gdk_screen_get_default ();
#line 74 "../src/game-window.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 74 "../src/game-window.vala"
		gdk_screen = _tmp3_;
#line 75 "../src/game-window.vala"
		_tmp4_ = gdk_screen;
#line 75 "../src/game-window.vala"
		if (_tmp4_ != NULL) {
#line 341 "game-window.c"
			GdkScreen* _tmp5_;
			GtkCssProvider* _tmp6_;
#line 76 "../src/game-window.vala"
			_tmp5_ = gdk_screen;
#line 76 "../src/game-window.vala"
			_tmp6_ = css_provider;
#line 76 "../src/game-window.vala"
			gtk_style_context_add_provider_for_screen (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gdk_screen_get_type (), GdkScreen), (GtkStyleProvider*) _tmp6_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 350 "game-window.c"
		}
#line 70 "../src/game-window.vala"
		_g_object_unref0 (gdk_screen);
#line 70 "../src/game-window.vala"
		_g_object_unref0 (css_provider);
#line 356 "game-window.c"
	}
#line 79 "../src/game-window.vala"
	_tmp7_ = _g_object_ref0 (_view);
#line 79 "../src/game-window.vala"
	_g_object_unref0 (self->priv->view);
#line 79 "../src/game-window.vala"
	self->priv->view = _tmp7_;
#line 82 "../src/game-window.vala"
	game_window_install_ui_action_entries (self);
#line 83 "../src/game-window.vala"
	gtk_window_set_title ((GtkWindow*) self, name);
#line 84 "../src/game-window.vala"
	_tmp8_ = self->priv->headerbar;
#line 84 "../src/game-window.vala"
	gtk_header_bar_set_title (_tmp8_, name);
#line 86 "../src/game-window.vala"
	gtk_window_set_default_size ((GtkWindow*) self, width, height);
#line 87 "../src/game-window.vala"
	if (maximized) {
#line 88 "../src/game-window.vala"
		gtk_window_maximize ((GtkWindow*) self);
#line 378 "game-window.c"
	}
#line 90 "../src/game-window.vala"
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) _game_window_size_allocate_cb_gtk_widget_size_allocate, self, 0);
#line 91 "../src/game-window.vala"
	g_signal_connect_object ((GtkWidget*) self, "window-state-event", (GCallback) _game_window_window_state_event_cb_gtk_widget_window_state_event, self, 0);
#line 94 "../src/game-window.vala"
	_tmp9_ = self->priv->new_game_box;
#line 94 "../src/game-window.vala"
	gtk_box_pack_start (_tmp9_, (GtkWidget*) new_game_screen, TRUE, TRUE, (guint) 0);
#line 95 "../src/game-window.vala"
	if ((flags & GAME_WINDOW_FLAGS_SHOW_START_BUTTON) == GAME_WINDOW_FLAGS_SHOW_START_BUTTON) {
#line 390 "game-window.c"
		GtkButton* _start_game_button = NULL;
		GtkButton* _tmp10_;
		GtkButton* _tmp11_;
		GtkButton* _tmp12_;
		GtkButton* _tmp13_;
		GtkButton* _tmp14_;
		GtkButton* _tmp15_;
		GtkStyleContext* _tmp16_;
		GtkButton* _tmp17_;
		GtkBox* _tmp18_;
		GtkButton* _tmp19_;
		GtkButton* _tmp20_;
		GtkButton* _tmp21_;
#line 98 "../src/game-window.vala"
		_tmp10_ = (GtkButton*) gtk_button_new_with_mnemonic (_ ("_Start Game"));
#line 98 "../src/game-window.vala"
		g_object_ref_sink (_tmp10_);
#line 98 "../src/game-window.vala"
		_start_game_button = _tmp10_;
#line 99 "../src/game-window.vala"
		_tmp11_ = _start_game_button;
#line 99 "../src/game-window.vala"
		g_object_set ((GtkWidget*) _tmp11_, "width-request", 222, NULL);
#line 100 "../src/game-window.vala"
		_tmp12_ = _start_game_button;
#line 100 "../src/game-window.vala"
		g_object_set ((GtkWidget*) _tmp12_, "height-request", 60, NULL);
#line 101 "../src/game-window.vala"
		_tmp13_ = _start_game_button;
#line 101 "../src/game-window.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp13_, GTK_ALIGN_CENTER);
#line 102 "../src/game-window.vala"
		_tmp14_ = _start_game_button;
#line 102 "../src/game-window.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp14_, "ui.start-game");
#line 105 "../src/game-window.vala"
		_tmp15_ = _start_game_button;
#line 105 "../src/game-window.vala"
		_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) _tmp15_);
#line 105 "../src/game-window.vala"
		gtk_style_context_add_class (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_style_context_get_type (), GtkStyleContext), "suggested-action");
#line 106 "../src/game-window.vala"
		_tmp17_ = _start_game_button;
#line 106 "../src/game-window.vala"
		gtk_widget_show ((GtkWidget*) _tmp17_);
#line 107 "../src/game-window.vala"
		_tmp18_ = self->priv->new_game_box;
#line 107 "../src/game-window.vala"
		_tmp19_ = _start_game_button;
#line 107 "../src/game-window.vala"
		gtk_box_pack_end (_tmp18_, (GtkWidget*) _tmp19_, FALSE, FALSE, (guint) 0);
#line 108 "../src/game-window.vala"
		_tmp20_ = _start_game_button;
#line 108 "../src/game-window.vala"
		_tmp21_ = _g_object_ref0 (_tmp20_);
#line 108 "../src/game-window.vala"
		_g_object_unref0 (self->priv->start_game_button);
#line 108 "../src/game-window.vala"
		self->priv->start_game_button = _tmp21_;
#line 95 "../src/game-window.vala"
		_g_object_unref0 (_start_game_button);
#line 452 "game-window.c"
	}
#line 111 "../src/game-window.vala"
	_tmp22_ = self->priv->game_box;
#line 111 "../src/game-window.vala"
	_tmp23_ = self->priv->view;
#line 111 "../src/game-window.vala"
	gtk_box_pack_start (_tmp22_, _tmp23_, TRUE, TRUE, (guint) 0);
#line 112 "../src/game-window.vala"
	_tmp24_ = self->priv->game_box;
#line 112 "../src/game-window.vala"
	_tmp25_ = self->priv->view;
#line 112 "../src/game-window.vala"
	gtk_container_set_focus_child ((GtkContainer*) _tmp24_, _tmp25_);
#line 113 "../src/game-window.vala"
	_tmp26_ = self->priv->view;
#line 113 "../src/game-window.vala"
	gtk_widget_set_halign (_tmp26_, GTK_ALIGN_FILL);
#line 114 "../src/game-window.vala"
	_tmp27_ = self->priv->view;
#line 114 "../src/game-window.vala"
	gtk_widget_set_can_focus (_tmp27_, TRUE);
#line 115 "../src/game-window.vala"
	_tmp28_ = self->priv->view;
#line 115 "../src/game-window.vala"
	gtk_widget_show (_tmp28_);
#line 118 "../src/game-window.vala"
	if ((flags & GAME_WINDOW_FLAGS_SHOW_UNDO) == GAME_WINDOW_FLAGS_SHOW_UNDO) {
#line 480 "game-window.c"
		GtkBox* history_box = NULL;
		GtkBox* _tmp29_;
		GtkBox* _tmp30_;
		GtkStyleContext* _tmp31_;
		GtkButton* undo_button = NULL;
		GtkButton* _tmp32_;
		GtkButton* _tmp33_;
		GtkButton* _tmp34_;
		GtkButton* _tmp35_;
		GtkButton* _tmp36_;
		GtkBox* _tmp37_;
		GtkButton* _tmp38_;
		GtkBox* _tmp39_;
		GtkBox* _tmp40_;
		GtkBox* _tmp41_;
#line 120 "../src/game-window.vala"
		_tmp29_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 120 "../src/game-window.vala"
		g_object_ref_sink (_tmp29_);
#line 120 "../src/game-window.vala"
		history_box = _tmp29_;
#line 121 "../src/game-window.vala"
		_tmp30_ = history_box;
#line 121 "../src/game-window.vala"
		_tmp31_ = gtk_widget_get_style_context ((GtkWidget*) _tmp30_);
#line 121 "../src/game-window.vala"
		gtk_style_context_add_class (_tmp31_, "linked");
#line 123 "../src/game-window.vala"
		_tmp32_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-undo-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 123 "../src/game-window.vala"
		g_object_ref_sink (_tmp32_);
#line 123 "../src/game-window.vala"
		undo_button = _tmp32_;
#line 124 "../src/game-window.vala"
		_tmp33_ = undo_button;
#line 124 "../src/game-window.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp33_, "ui.undo");
#line 126 "../src/game-window.vala"
		_tmp34_ = undo_button;
#line 126 "../src/game-window.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp34_, _ ("Undo your most recent move"));
#line 127 "../src/game-window.vala"
		_tmp35_ = undo_button;
#line 127 "../src/game-window.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp35_, GTK_ALIGN_CENTER);
#line 128 "../src/game-window.vala"
		_tmp36_ = undo_button;
#line 128 "../src/game-window.vala"
		gtk_widget_show ((GtkWidget*) _tmp36_);
#line 129 "../src/game-window.vala"
		_tmp37_ = history_box;
#line 129 "../src/game-window.vala"
		_tmp38_ = undo_button;
#line 129 "../src/game-window.vala"
		gtk_box_pack_start (_tmp37_, (GtkWidget*) _tmp38_, TRUE, TRUE, (guint) 0);
#line 142 "../src/game-window.vala"
		_tmp39_ = history_box;
#line 142 "../src/game-window.vala"
		gtk_widget_show ((GtkWidget*) _tmp39_);
#line 143 "../src/game-window.vala"
		_tmp40_ = self->priv->controls_box;
#line 143 "../src/game-window.vala"
		_tmp41_ = history_box;
#line 143 "../src/game-window.vala"
		gtk_box_pack_start (_tmp40_, (GtkWidget*) _tmp41_, TRUE, TRUE, (guint) 0);
#line 118 "../src/game-window.vala"
		_g_object_unref0 (undo_button);
#line 118 "../src/game-window.vala"
		_g_object_unref0 (history_box);
#line 550 "game-window.c"
	}
#line 157 "../src/game-window.vala"
	if (start_now) {
#line 158 "../src/game-window.vala"
		game_window_show_view (self);
#line 556 "game-window.c"
	} else {
#line 160 "../src/game-window.vala"
		game_window_show_new_game_screen (self);
#line 560 "game-window.c"
	}
#line 68 "../src/game-window.vala"
	return self;
#line 564 "game-window.c"
}

GameWindow*
game_window_new (const gchar* css_resource,
                 const gchar* name,
                 gint width,
                 gint height,
                 gboolean maximized,
                 gboolean start_now,
                 GameWindowFlags flags,
                 GtkBox* new_game_screen,
                 GtkWidget* _view)
{
#line 68 "../src/game-window.vala"
	return game_window_construct (TYPE_GAME_WINDOW, css_resource, name, width, height, maximized, start_now, flags, new_game_screen, _view);
#line 580 "game-window.c"
}

static void
game_window_install_ui_action_entries (GameWindow* self)
{
	GSimpleActionGroup* action_group = NULL;
	GSimpleActionGroup* _tmp0_;
	GAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GAction* _tmp3_;
	GSimpleAction* _tmp4_;
	GSimpleAction* _tmp5_;
	GSimpleAction* _tmp6_;
#line 171 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 173 "../src/game-window.vala"
	_tmp0_ = g_simple_action_group_new ();
#line 173 "../src/game-window.vala"
	action_group = _tmp0_;
#line 174 "../src/game-window.vala"
	g_action_map_add_action_entries ((GActionMap*) action_group, GAME_WINDOW_ui_action_entries, (gint) G_N_ELEMENTS (GAME_WINDOW_ui_action_entries), self);
#line 175 "../src/game-window.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "ui", (GActionGroup*) action_group);
#line 177 "../src/game-window.vala"
	_tmp1_ = g_action_map_lookup_action ((GActionMap*) action_group, "back");
#line 177 "../src/game-window.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_simple_action_get_type (), GSimpleAction));
#line 177 "../src/game-window.vala"
	_g_object_unref0 (self->priv->back_action);
#line 177 "../src/game-window.vala"
	self->priv->back_action = _tmp2_;
#line 178 "../src/game-window.vala"
	_tmp3_ = g_action_map_lookup_action ((GActionMap*) action_group, "undo");
#line 178 "../src/game-window.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_simple_action_get_type (), GSimpleAction));
#line 178 "../src/game-window.vala"
	_g_object_unref0 (self->priv->undo_action);
#line 178 "../src/game-window.vala"
	self->priv->undo_action = _tmp4_;
#line 181 "../src/game-window.vala"
	_tmp5_ = self->priv->back_action;
#line 181 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp5_, FALSE);
#line 182 "../src/game-window.vala"
	_tmp6_ = self->priv->undo_action;
#line 182 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp6_, FALSE);
#line 171 "../src/game-window.vala"
	_g_object_unref0 (action_group);
#line 630 "game-window.c"
}

static void
game_window_size_allocate_cb (GameWindow* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
#line 204 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 206 "../src/game-window.vala"
	if (self->priv->window_is_maximized) {
#line 206 "../src/game-window.vala"
		_tmp1_ = TRUE;
#line 646 "game-window.c"
	} else {
#line 206 "../src/game-window.vala"
		_tmp1_ = self->priv->window_is_tiled;
#line 650 "game-window.c"
	}
#line 206 "../src/game-window.vala"
	if (_tmp1_) {
#line 206 "../src/game-window.vala"
		_tmp0_ = TRUE;
#line 656 "game-window.c"
	} else {
#line 206 "../src/game-window.vala"
		_tmp0_ = self->priv->window_is_fullscreen;
#line 660 "game-window.c"
	}
#line 206 "../src/game-window.vala"
	if (_tmp0_) {
#line 207 "../src/game-window.vala"
		return;
#line 666 "game-window.c"
	}
#line 208 "../src/game-window.vala"
	gtk_window_get_size ((GtkWindow*) self, &_tmp2_, &_tmp3_);
#line 208 "../src/game-window.vala"
	self->priv->window_width = _tmp2_;
#line 208 "../src/game-window.vala"
	self->priv->window_height = _tmp3_;
#line 674 "game-window.c"
}

static gboolean
game_window_window_state_event_cb (GameWindow* self,
                                   GdkEventWindowState* event)
{
	gboolean result = FALSE;
	GdkWindowState _tmp0_;
	gboolean window_was_fullscreen = FALSE;
	GdkWindowState _tmp2_;
	gboolean _tmp4_ = FALSE;
	GdkWindowState tiled_state = 0U;
	GdkWindowState _tmp8_;
	GdkWindowState _tmp9_;
#line 211 "../src/game-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 211 "../src/game-window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 213 "../src/game-window.vala"
	_tmp0_ = event->changed_mask;
#line 213 "../src/game-window.vala"
	if ((_tmp0_ & GDK_WINDOW_STATE_MAXIMIZED) != 0) {
#line 697 "game-window.c"
		GdkWindowState _tmp1_;
#line 214 "../src/game-window.vala"
		_tmp1_ = event->new_window_state;
#line 214 "../src/game-window.vala"
		self->priv->window_is_maximized = (_tmp1_ & GDK_WINDOW_STATE_MAXIMIZED) != 0;
#line 703 "game-window.c"
	}
#line 217 "../src/game-window.vala"
	window_was_fullscreen = self->priv->window_is_fullscreen;
#line 218 "../src/game-window.vala"
	_tmp2_ = event->changed_mask;
#line 218 "../src/game-window.vala"
	if ((_tmp2_ & GDK_WINDOW_STATE_FULLSCREEN) != 0) {
#line 711 "game-window.c"
		GdkWindowState _tmp3_;
#line 219 "../src/game-window.vala"
		_tmp3_ = event->new_window_state;
#line 219 "../src/game-window.vala"
		self->priv->window_is_fullscreen = (_tmp3_ & GDK_WINDOW_STATE_FULLSCREEN) != 0;
#line 717 "game-window.c"
	}
#line 220 "../src/game-window.vala"
	if (window_was_fullscreen) {
#line 220 "../src/game-window.vala"
		_tmp4_ = !self->priv->window_is_fullscreen;
#line 723 "game-window.c"
	} else {
#line 220 "../src/game-window.vala"
		_tmp4_ = FALSE;
#line 727 "game-window.c"
	}
#line 220 "../src/game-window.vala"
	if (_tmp4_) {
#line 731 "game-window.c"
		GtkButton* _tmp5_;
#line 221 "../src/game-window.vala"
		_tmp5_ = self->priv->unfullscreen_button;
#line 221 "../src/game-window.vala"
		gtk_widget_hide ((GtkWidget*) _tmp5_);
#line 737 "game-window.c"
	} else {
		gboolean _tmp6_ = FALSE;
#line 222 "../src/game-window.vala"
		if (!window_was_fullscreen) {
#line 222 "../src/game-window.vala"
			_tmp6_ = self->priv->window_is_fullscreen;
#line 744 "game-window.c"
		} else {
#line 222 "../src/game-window.vala"
			_tmp6_ = FALSE;
#line 748 "game-window.c"
		}
#line 222 "../src/game-window.vala"
		if (_tmp6_) {
#line 752 "game-window.c"
			GtkButton* _tmp7_;
#line 223 "../src/game-window.vala"
			_tmp7_ = self->priv->unfullscreen_button;
#line 223 "../src/game-window.vala"
			gtk_widget_show ((GtkWidget*) _tmp7_);
#line 758 "game-window.c"
		}
	}
#line 226 "../src/game-window.vala"
	tiled_state = (((GDK_WINDOW_STATE_TILED | GDK_WINDOW_STATE_TOP_TILED) | GDK_WINDOW_STATE_BOTTOM_TILED) | GDK_WINDOW_STATE_LEFT_TILED) | GDK_WINDOW_STATE_RIGHT_TILED;
#line 231 "../src/game-window.vala"
	_tmp8_ = event->changed_mask;
#line 231 "../src/game-window.vala"
	_tmp9_ = tiled_state;
#line 231 "../src/game-window.vala"
	if ((_tmp8_ & _tmp9_) != 0) {
#line 769 "game-window.c"
		GdkWindowState _tmp10_;
		GdkWindowState _tmp11_;
#line 232 "../src/game-window.vala"
		_tmp10_ = event->new_window_state;
#line 232 "../src/game-window.vala"
		_tmp11_ = tiled_state;
#line 232 "../src/game-window.vala"
		self->priv->window_is_tiled = (_tmp10_ & _tmp11_) != 0;
#line 778 "game-window.c"
	}
#line 234 "../src/game-window.vala"
	result = FALSE;
#line 234 "../src/game-window.vala"
	return result;
#line 784 "game-window.c"
}

void
game_window_shutdown (GameWindow* self,
                      GSettings* settings)
{
	gboolean _tmp0_ = FALSE;
#line 237 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 237 "../src/game-window.vala"
	g_return_if_fail (settings != NULL);
#line 239 "../src/game-window.vala"
	g_settings_delay (settings);
#line 240 "../src/game-window.vala"
	g_settings_set_int (settings, "window-width", self->priv->window_width);
#line 241 "../src/game-window.vala"
	g_settings_set_int (settings, "window-height", self->priv->window_height);
#line 242 "../src/game-window.vala"
	if (self->priv->window_is_maximized) {
#line 242 "../src/game-window.vala"
		_tmp0_ = TRUE;
#line 806 "game-window.c"
	} else {
#line 242 "../src/game-window.vala"
		_tmp0_ = self->priv->window_is_fullscreen;
#line 810 "game-window.c"
	}
#line 242 "../src/game-window.vala"
	g_settings_set_boolean (settings, "window-is-maximized", _tmp0_);
#line 243 "../src/game-window.vala"
	g_settings_apply (settings);
#line 244 "../src/game-window.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 818 "game-window.c"
}

void
game_window_add_to_sidebox (GameWindow* self,
                            GtkWidget* widget)
{
	GtkBox* _tmp0_;
#line 251 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 251 "../src/game-window.vala"
	g_return_if_fail (widget != NULL);
#line 253 "../src/game-window.vala"
	_tmp0_ = self->priv->side_box;
#line 253 "../src/game-window.vala"
	gtk_box_pack_start (_tmp0_, widget, FALSE, FALSE, (guint) 0);
#line 834 "game-window.c"
}

void
game_window_cannot_undo_more (GameWindow* self)
{
	GSimpleAction* _tmp0_;
	GtkWidget* _tmp1_;
#line 256 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 258 "../src/game-window.vala"
	_tmp0_ = self->priv->undo_action;
#line 258 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp0_, FALSE);
#line 259 "../src/game-window.vala"
	_tmp1_ = self->priv->view;
#line 259 "../src/game-window.vala"
	gtk_widget_grab_focus (_tmp1_);
#line 852 "game-window.c"
}

void
game_window_new_turn_start (GameWindow* self,
                            gboolean can_undo)
{
	GSimpleAction* _tmp0_;
	GtkHeaderBar* _tmp1_;
#line 262 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 264 "../src/game-window.vala"
	_tmp0_ = self->priv->undo_action;
#line 264 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp0_, can_undo);
#line 265 "../src/game-window.vala"
	_tmp1_ = self->priv->headerbar;
#line 265 "../src/game-window.vala"
	gtk_header_bar_set_subtitle (_tmp1_, NULL);
#line 871 "game-window.c"
}

void
game_window_set_subtitle (GameWindow* self,
                          const gchar* subtitle)
{
	GtkHeaderBar* _tmp0_;
#line 268 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 268 "../src/game-window.vala"
	g_return_if_fail (subtitle != NULL);
#line 270 "../src/game-window.vala"
	_tmp0_ = self->priv->headerbar;
#line 270 "../src/game-window.vala"
	gtk_header_bar_set_subtitle (_tmp0_, subtitle);
#line 887 "game-window.c"
}

void
game_window_finish_game (GameWindow* self)
{
	GtkButton* _tmp0_;
#line 273 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 275 "../src/game-window.vala"
	self->priv->game_finished = TRUE;
#line 276 "../src/game-window.vala"
	_tmp0_ = self->priv->new_game_button;
#line 276 "../src/game-window.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
#line 902 "game-window.c"
}

static void
game_window_show_new_game_screen (GameWindow* self)
{
	GtkHeaderBar* _tmp0_;
	GtkStack* _tmp1_;
	GtkBox* _tmp2_;
	gboolean _tmp3_ = FALSE;
#line 288 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 290 "../src/game-window.vala"
	_tmp0_ = self->priv->headerbar;
#line 290 "../src/game-window.vala"
	gtk_header_bar_set_subtitle (_tmp0_, NULL);
#line 292 "../src/game-window.vala"
	_tmp1_ = self->priv->stack;
#line 292 "../src/game-window.vala"
	gtk_stack_set_visible_child_name (_tmp1_, "start-box");
#line 293 "../src/game-window.vala"
	_tmp2_ = self->priv->controls_box;
#line 293 "../src/game-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp2_);
#line 295 "../src/game-window.vala"
	if (!self->priv->game_finished) {
#line 928 "game-window.c"
		GtkButton* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 295 "../src/game-window.vala"
		_tmp4_ = self->priv->back_button;
#line 295 "../src/game-window.vala"
		_tmp5_ = gtk_widget_get_visible ((GtkWidget*) _tmp4_);
#line 295 "../src/game-window.vala"
		_tmp6_ = _tmp5_;
#line 295 "../src/game-window.vala"
		_tmp3_ = _tmp6_;
#line 940 "game-window.c"
	} else {
#line 295 "../src/game-window.vala"
		_tmp3_ = FALSE;
#line 944 "game-window.c"
	}
#line 295 "../src/game-window.vala"
	if (_tmp3_) {
#line 948 "game-window.c"
		GtkButton* _tmp7_;
#line 296 "../src/game-window.vala"
		_tmp7_ = self->priv->back_button;
#line 296 "../src/game-window.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp7_);
#line 954 "game-window.c"
	} else {
		GtkButton* _tmp8_;
#line 297 "../src/game-window.vala"
		_tmp8_ = self->priv->start_game_button;
#line 297 "../src/game-window.vala"
		if (_tmp8_ != NULL) {
#line 961 "game-window.c"
			GtkButton* _tmp9_;
#line 298 "../src/game-window.vala"
			_tmp9_ = self->priv->start_game_button;
#line 298 "../src/game-window.vala"
			gtk_widget_grab_focus ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_button_get_type (), GtkButton));
#line 967 "game-window.c"
		}
	}
}

static void
game_window_show_view (GameWindow* self)
{
	GtkStack* _tmp0_;
	GtkButton* _tmp1_;
	GtkBox* _tmp2_;
#line 301 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 303 "../src/game-window.vala"
	_tmp0_ = self->priv->stack;
#line 303 "../src/game-window.vala"
	gtk_stack_set_visible_child_name (_tmp0_, "frame");
#line 304 "../src/game-window.vala"
	_tmp1_ = self->priv->back_button;
#line 304 "../src/game-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 305 "../src/game-window.vala"
	_tmp2_ = self->priv->controls_box;
#line 305 "../src/game-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp2_);
#line 307 "../src/game-window.vala"
	if (self->priv->game_finished) {
#line 994 "game-window.c"
		GtkButton* _tmp3_;
#line 308 "../src/game-window.vala"
		_tmp3_ = self->priv->new_game_button;
#line 308 "../src/game-window.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp3_);
#line 1000 "game-window.c"
	} else {
		GtkWidget* _tmp4_;
#line 310 "../src/game-window.vala"
		_tmp4_ = self->priv->view;
#line 310 "../src/game-window.vala"
		gtk_widget_grab_focus (_tmp4_);
#line 1007 "game-window.c"
	}
}

static void
game_window_new_game_cb (GameWindow* self)
{
	gchar* stack_child = NULL;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	GtkStack* _tmp6_;
	GtkStack* _tmp7_;
	GtkButton* _tmp8_;
	GSimpleAction* _tmp9_;
#line 317 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 319 "../src/game-window.vala"
	_tmp0_ = self->priv->stack;
#line 319 "../src/game-window.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 319 "../src/game-window.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 319 "../src/game-window.vala"
	stack_child = _tmp2_;
#line 320 "../src/game-window.vala"
	_tmp4_ = stack_child;
#line 320 "../src/game-window.vala"
	if (_tmp4_ == NULL) {
#line 320 "../src/game-window.vala"
		_tmp3_ = TRUE;
#line 1040 "game-window.c"
	} else {
		const gchar* _tmp5_;
#line 320 "../src/game-window.vala"
		_tmp5_ = stack_child;
#line 320 "../src/game-window.vala"
		_tmp3_ = g_strcmp0 ((const gchar*) _tmp5_, "frame") != 0;
#line 1047 "game-window.c"
	}
#line 320 "../src/game-window.vala"
	if (_tmp3_) {
#line 321 "../src/game-window.vala"
		_g_free0 (stack_child);
#line 321 "../src/game-window.vala"
		return;
#line 1055 "game-window.c"
	}
#line 323 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_WAIT_SIGNAL], 0);
#line 325 "../src/game-window.vala"
	_tmp6_ = self->priv->stack;
#line 325 "../src/game-window.vala"
	gtk_stack_set_transition_type (_tmp6_, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT);
#line 326 "../src/game-window.vala"
	_tmp7_ = self->priv->stack;
#line 326 "../src/game-window.vala"
	gtk_stack_set_transition_duration (_tmp7_, (guint) 800);
#line 328 "../src/game-window.vala"
	_tmp8_ = self->priv->back_button;
#line 328 "../src/game-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp8_);
#line 329 "../src/game-window.vala"
	_tmp9_ = self->priv->back_action;
#line 329 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp9_, TRUE);
#line 331 "../src/game-window.vala"
	game_window_show_new_game_screen (self);
#line 317 "../src/game-window.vala"
	_g_free0 (stack_child);
#line 1079 "game-window.c"
}

static void
game_window_start_game_cb (GameWindow* self)
{
	gchar* stack_child = NULL;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	GSimpleAction* _tmp6_;
	GtkStack* _tmp7_;
	GtkStack* _tmp8_;
#line 334 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 336 "../src/game-window.vala"
	_tmp0_ = self->priv->stack;
#line 336 "../src/game-window.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 336 "../src/game-window.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 336 "../src/game-window.vala"
	stack_child = _tmp2_;
#line 337 "../src/game-window.vala"
	_tmp4_ = stack_child;
#line 337 "../src/game-window.vala"
	if (_tmp4_ == NULL) {
#line 337 "../src/game-window.vala"
		_tmp3_ = TRUE;
#line 1110 "game-window.c"
	} else {
		const gchar* _tmp5_;
#line 337 "../src/game-window.vala"
		_tmp5_ = stack_child;
#line 337 "../src/game-window.vala"
		_tmp3_ = g_strcmp0 ((const gchar*) _tmp5_, "start-box") != 0;
#line 1117 "game-window.c"
	}
#line 337 "../src/game-window.vala"
	if (_tmp3_) {
#line 338 "../src/game-window.vala"
		_g_free0 (stack_child);
#line 338 "../src/game-window.vala"
		return;
#line 1125 "game-window.c"
	}
#line 340 "../src/game-window.vala"
	self->priv->game_finished = FALSE;
#line 342 "../src/game-window.vala"
	_tmp6_ = self->priv->undo_action;
#line 342 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp6_, FALSE);
#line 345 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_PLAY_SIGNAL], 0);
#line 347 "../src/game-window.vala"
	_tmp7_ = self->priv->stack;
#line 347 "../src/game-window.vala"
	gtk_stack_set_transition_type (_tmp7_, GTK_STACK_TRANSITION_TYPE_SLIDE_DOWN);
#line 348 "../src/game-window.vala"
	_tmp8_ = self->priv->stack;
#line 348 "../src/game-window.vala"
	gtk_stack_set_transition_duration (_tmp8_, (guint) 1000);
#line 349 "../src/game-window.vala"
	game_window_show_view (self);
#line 334 "../src/game-window.vala"
	_g_free0 (stack_child);
#line 1147 "game-window.c"
}

static void
game_window_back_cb (GameWindow* self)
{
	gchar* stack_child = NULL;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	GtkStack* _tmp6_;
	GtkStack* _tmp7_;
#line 352 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 354 "../src/game-window.vala"
	_tmp0_ = self->priv->stack;
#line 354 "../src/game-window.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 354 "../src/game-window.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 354 "../src/game-window.vala"
	stack_child = _tmp2_;
#line 355 "../src/game-window.vala"
	_tmp4_ = stack_child;
#line 355 "../src/game-window.vala"
	if (_tmp4_ == NULL) {
#line 355 "../src/game-window.vala"
		_tmp3_ = TRUE;
#line 1177 "game-window.c"
	} else {
		const gchar* _tmp5_;
#line 355 "../src/game-window.vala"
		_tmp5_ = stack_child;
#line 355 "../src/game-window.vala"
		_tmp3_ = g_strcmp0 ((const gchar*) _tmp5_, "start-box") != 0;
#line 1184 "game-window.c"
	}
#line 355 "../src/game-window.vala"
	if (_tmp3_) {
#line 356 "../src/game-window.vala"
		_g_free0 (stack_child);
#line 356 "../src/game-window.vala"
		return;
#line 1192 "game-window.c"
	}
#line 358 "../src/game-window.vala"
	_tmp6_ = self->priv->stack;
#line 358 "../src/game-window.vala"
	gtk_stack_set_transition_type (_tmp6_, GTK_STACK_TRANSITION_TYPE_SLIDE_RIGHT);
#line 359 "../src/game-window.vala"
	_tmp7_ = self->priv->stack;
#line 359 "../src/game-window.vala"
	gtk_stack_set_transition_duration (_tmp7_, (guint) 800);
#line 360 "../src/game-window.vala"
	game_window_show_view (self);
#line 362 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_BACK_SIGNAL], 0);
#line 352 "../src/game-window.vala"
	_g_free0 (stack_child);
#line 1208 "game-window.c"
}

static void
game_window_undo_cb (GameWindow* self)
{
	gchar* stack_child = NULL;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkButton* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
#line 369 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 371 "../src/game-window.vala"
	_tmp0_ = self->priv->stack;
#line 371 "../src/game-window.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 371 "../src/game-window.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 371 "../src/game-window.vala"
	stack_child = _tmp2_;
#line 372 "../src/game-window.vala"
	_tmp3_ = stack_child;
#line 372 "../src/game-window.vala"
	if (_tmp3_ == NULL) {
#line 373 "../src/game-window.vala"
		_g_free0 (stack_child);
#line 373 "../src/game-window.vala"
		return;
#line 1241 "game-window.c"
	}
#line 374 "../src/game-window.vala"
	_tmp4_ = stack_child;
#line 374 "../src/game-window.vala"
	if (g_strcmp0 ((const gchar*) _tmp4_, "frame") != 0) {
#line 1247 "game-window.c"
		GSimpleAction* _tmp5_;
#line 376 "../src/game-window.vala"
		_tmp5_ = self->priv->back_action;
#line 376 "../src/game-window.vala"
		if (g_action_get_enabled ((GAction*) _tmp5_)) {
#line 377 "../src/game-window.vala"
			game_window_back_cb (self);
#line 1255 "game-window.c"
		}
#line 378 "../src/game-window.vala"
		_g_free0 (stack_child);
#line 378 "../src/game-window.vala"
		return;
#line 1261 "game-window.c"
	}
#line 381 "../src/game-window.vala"
	self->priv->game_finished = FALSE;
#line 383 "../src/game-window.vala"
	_tmp6_ = self->priv->back_button;
#line 383 "../src/game-window.vala"
	g_object_get ((GtkWidget*) _tmp6_, "is-focus", &_tmp7_, NULL);
#line 383 "../src/game-window.vala"
	_tmp8_ = _tmp7_;
#line 383 "../src/game-window.vala"
	if (!_tmp8_) {
#line 1273 "game-window.c"
		GtkWidget* _tmp9_;
#line 384 "../src/game-window.vala"
		_tmp9_ = self->priv->view;
#line 384 "../src/game-window.vala"
		gtk_widget_grab_focus (_tmp9_);
#line 1279 "game-window.c"
	}
#line 386 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_UNDO_SIGNAL], 0);
#line 369 "../src/game-window.vala"
	_g_free0 (stack_child);
#line 1285 "game-window.c"
}

static void
game_window_toggle_hamburger (GameWindow* self)
{
	GtkMenuButton* _tmp0_;
	GtkMenuButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 415 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 417 "../src/game-window.vala"
	_tmp0_ = self->priv->info_button;
#line 417 "../src/game-window.vala"
	_tmp1_ = self->priv->info_button;
#line 417 "../src/game-window.vala"
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
#line 417 "../src/game-window.vala"
	_tmp3_ = _tmp2_;
#line 417 "../src/game-window.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, !_tmp3_);
#line 1307 "game-window.c"
}

static void
game_window_class_init (GameWindowClass * klass,
                        gpointer klass_data)
{
#line 32 "../src/game-window.vala"
	game_window_parent_class = g_type_class_peek_parent (klass);
#line 32 "../src/game-window.vala"
	g_type_class_adjust_private_offset (klass, &GameWindow_private_offset);
#line 32 "../src/game-window.vala"
	G_OBJECT_CLASS (klass)->finalize = game_window_finalize;
#line 32 "../src/game-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Reversi/ui/game-window.ui");
#line 32 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_PLAY_SIGNAL] = g_signal_new ("play", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 32 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_WAIT_SIGNAL] = g_signal_new ("wait", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 32 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_BACK_SIGNAL] = g_signal_new ("back", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 32 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_UNDO_SIGNAL] = g_signal_new ("undo", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 32 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "headerbar", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, headerbar));
#line 32 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stack", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, stack));
#line 32 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "new_game_button", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, new_game_button));
#line 32 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "back_button", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, back_button));
#line 32 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "unfullscreen_button", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, unfullscreen_button));
#line 32 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "controls_box", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, controls_box));
#line 32 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "game_box", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, game_box));
#line 32 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "new_game_box", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, new_game_box));
#line 32 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "side_box", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, side_box));
#line 32 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "info_button", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, info_button));
#line 1350 "game-window.c"
}

static void
game_window_instance_init (GameWindow * self,
                           gpointer klass)
{
#line 32 "../src/game-window.vala"
	self->priv = game_window_get_instance_private (self);
#line 41 "../src/game-window.vala"
	self->priv->game_finished = FALSE;
#line 47 "../src/game-window.vala"
	self->priv->start_game_button = NULL;
#line 32 "../src/game-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1365 "game-window.c"
}

static void
game_window_finalize (GObject * obj)
{
	GameWindow * self;
#line 32 "../src/game-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_WINDOW, GameWindow);
#line 44 "../src/game-window.vala"
	_g_object_unref0 (self->priv->headerbar);
#line 45 "../src/game-window.vala"
	_g_object_unref0 (self->priv->stack);
#line 47 "../src/game-window.vala"
	_g_object_unref0 (self->priv->start_game_button);
#line 48 "../src/game-window.vala"
	_g_object_unref0 (self->priv->new_game_button);
#line 49 "../src/game-window.vala"
	_g_object_unref0 (self->priv->back_button);
#line 50 "../src/game-window.vala"
	_g_object_unref0 (self->priv->unfullscreen_button);
#line 52 "../src/game-window.vala"
	_g_object_unref0 (self->priv->controls_box);
#line 53 "../src/game-window.vala"
	_g_object_unref0 (self->priv->game_box);
#line 54 "../src/game-window.vala"
	_g_object_unref0 (self->priv->new_game_box);
#line 55 "../src/game-window.vala"
	_g_object_unref0 (self->priv->side_box);
#line 57 "../src/game-window.vala"
	_g_object_unref0 (self->priv->view);
#line 167 "../src/game-window.vala"
	_g_object_unref0 (self->priv->back_action);
#line 168 "../src/game-window.vala"
	_g_object_unref0 (self->priv->undo_action);
#line 413 "../src/game-window.vala"
	_g_object_unref0 (self->priv->info_button);
#line 32 "../src/game-window.vala"
	G_OBJECT_CLASS (game_window_parent_class)->finalize (obj);
#line 1404 "game-window.c"
}

GType
game_window_get_type (void)
{
	static volatile gsize game_window_type_id__volatile = 0;
	if (g_once_init_enter (&game_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameWindow), 0, (GInstanceInitFunc) game_window_instance_init, NULL };
		GType game_window_type_id;
		game_window_type_id = g_type_register_static (gtk_application_window_get_type (), "GameWindow", &g_define_type_info, 0);
		GameWindow_private_offset = g_type_add_instance_private (game_window_type_id, sizeof (GameWindowPrivate));
		g_once_init_leave (&game_window_type_id__volatile, game_window_type_id);
	}
	return game_window_type_id__volatile;
}

